diff -urNEBb binutils-2.14-orig/binutils/rename.c binutils-2.14/binutils/rename.c
--- binutils-2.14-orig/binutils/rename.c	2002-11-30 09:39:40.000000000 +0100
+++ binutils-2.14/binutils/rename.c	2003-12-02 17:43:31.000000000 +0100
@@ -156,7 +156,7 @@
 
   exists = lstat (to, &s) == 0;
 
-#if defined (_WIN32) && !defined (__CYGWIN32__)
+#if defined (_WIN32) && !defined (__CYGWIN32__) || defined (__amigaos4__)
   /* Win32, unlike unix, will not erase `to' in `rename(from, to)' but
      fail instead.  Also, chown is not present.  */
 
diff -urNEBb binutils-2.14-orig/binutils/rename.c.orig binutils-2.14/binutils/rename.c.orig
--- binutils-2.14-orig/binutils/rename.c.orig	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/binutils/rename.c.orig	2003-12-02 17:37:52.000000000 +0100
@@ -0,0 +1,221 @@
+/* rename.c -- rename a file, preserving symlinks.
+   Copyright 1999, 2002 Free Software Foundation, Inc.
+
+   This file is part of GNU Binutils.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
+   02111-1307, USA.  */
+
+#include "bfd.h"
+#include "bucomm.h"
+
+#include <sys/stat.h>
+
+#ifdef HAVE_GOOD_UTIME_H
+#include <utime.h>
+#else /* ! HAVE_GOOD_UTIME_H */
+#ifdef HAVE_UTIMES
+#include <sys/time.h>
+#endif /* HAVE_UTIMES */
+#endif /* ! HAVE_GOOD_UTIME_H */
+
+/* We need to open the file in binary modes on system where that makes
+   a difference.  */
+#ifndef O_BINARY
+#define O_BINARY 0
+#endif
+
+static int simple_copy
+  PARAMS ((const char *, const char *));
+
+/* The number of bytes to copy at once.  */
+#define COPY_BUF 8192
+
+/* Copy file FROM to file TO, performing no translations.
+   Return 0 if ok, -1 if error.  */
+
+static int
+simple_copy (from, to)
+     const char *from;
+     const char *to;
+{
+  int fromfd, tofd, nread;
+  int saved;
+  char buf[COPY_BUF];
+
+  fromfd = open (from, O_RDONLY | O_BINARY);
+  if (fromfd < 0)
+    return -1;
+#ifdef O_CREAT
+  tofd = open (to, O_CREAT | O_WRONLY | O_TRUNC | O_BINARY, 0777);
+#else
+  tofd = creat (to, 0777);
+#endif
+  if (tofd < 0)
+    {
+      saved = errno;
+      close (fromfd);
+      errno = saved;
+      return -1;
+    }
+  while ((nread = read (fromfd, buf, sizeof buf)) > 0)
+    {
+      if (write (tofd, buf, nread) != nread)
+	{
+	  saved = errno;
+	  close (fromfd);
+	  close (tofd);
+	  errno = saved;
+	  return -1;
+	}
+    }
+  saved = errno;
+  close (fromfd);
+  close (tofd);
+  if (nread < 0)
+    {
+      errno = saved;
+      return -1;
+    }
+  return 0;
+}
+
+/* Set the times of the file DESTINATION to be the same as those in
+   STATBUF.  */
+
+void
+set_times (destination, statbuf)
+     const char *destination;
+     const struct stat *statbuf;
+{
+  int result;
+
+  {
+#ifdef HAVE_GOOD_UTIME_H
+    struct utimbuf tb;
+
+    tb.actime = statbuf->st_atime;
+    tb.modtime = statbuf->st_mtime;
+    result = utime (destination, &tb);
+#else /* ! HAVE_GOOD_UTIME_H */
+#ifndef HAVE_UTIMES
+    long tb[2];
+
+    tb[0] = statbuf->st_atime;
+    tb[1] = statbuf->st_mtime;
+    result = utime (destination, tb);
+#else /* HAVE_UTIMES */
+    struct timeval tv[2];
+
+    tv[0].tv_sec = statbuf->st_atime;
+    tv[0].tv_usec = 0;
+    tv[1].tv_sec = statbuf->st_mtime;
+    tv[1].tv_usec = 0;
+    result = utimes (destination, tv);
+#endif /* HAVE_UTIMES */
+#endif /* ! HAVE_GOOD_UTIME_H */
+  }
+
+  if (result != 0)
+    non_fatal (_("%s: cannot set time: %s"), destination, strerror (errno));
+}
+
+#ifndef S_ISLNK
+#ifdef S_IFLNK
+#define S_ISLNK(m) (((m) & S_IFMT) == S_IFLNK)
+#else
+#define S_ISLNK(m) 0
+#define lstat stat
+#endif
+#endif
+
+/* Rename FROM to TO, copying if TO is a link.
+   Return 0 if ok, -1 if error.  */
+
+int
+smart_rename (from, to, preserve_dates)
+     const char *from;
+     const char *to;
+     int preserve_dates;
+{
+  bfd_boolean exists;
+  struct stat s;
+  int ret = 0;
+
+  exists = lstat (to, &s) == 0;
+
+#if defined (_WIN32) && !defined (__CYGWIN32__) || defined (__amigaos4__)
+  /* Win32, unlike unix, will not erase `to' in `rename(from, to)' but
+     fail instead.  Also, chown is not present.  */
+
+  if (exists)
+    remove (to);
+
+  ret = rename (from, to);
+  if (ret != 0)
+    {
+      /* We have to clean up here.  */
+
+      non_fatal (_("%s: rename: %s"), to, strerror (errno));
+      unlink (from);
+    }
+#else
+  /* Use rename only if TO is not a symbolic link and has
+     only one hard link.  */
+  if (! exists || (!S_ISLNK (s.st_mode) && s.st_nlink == 1))
+    {
+      ret = rename (from, to);
+      if (ret == 0)
+	{
+	  if (exists)
+	    {
+	      /* Try to preserve the permission bits and ownership of
+		 TO.  First get the mode right except for the setuid
+		 bit.  Then change the ownership.  Then fix the setuid
+		 bit.  We do the chmod before the chown because if the
+		 chown succeeds, and we are a normal user, we won't be
+		 able to do the chmod afterward.  We don't bother to
+		 fix the setuid bit first because that might introduce
+		 a fleeting security problem, and because the chown
+		 will clear the setuid bit anyhow.  We only fix the
+		 setuid bit if the chown succeeds, because we don't
+		 want to introduce an unexpected setuid file owned by
+		 the user running objcopy.  */
+	      chmod (to, s.st_mode & 0777);
+	      if (chown (to, s.st_uid, s.st_gid) >= 0)
+		chmod (to, s.st_mode & 07777);
+	    }
+	}
+      else
+	{
+	  /* We have to clean up here.  */
+	  non_fatal (_("%s: rename: %s"), to, strerror (errno));
+	  unlink (from);
+	}
+    }
+  else
+    {
+      ret = simple_copy (from, to);
+      if (ret != 0)
+	non_fatal (_("%s: simple_copy: %s"), to, strerror (errno));
+
+      if (preserve_dates)
+	set_times (to, &s);
+      unlink (from);
+    }
+#endif /* _WIN32 && !__CYGWIN32__ */
+
+  return ret;
+}
diff -urNEBb binutils-2.14-orig/binutils/rename.c.rej binutils-2.14/binutils/rename.c.rej
--- binutils-2.14-orig/binutils/rename.c.rej	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/binutils/rename.c.rej	2003-12-02 17:43:31.000000000 +0100
@@ -0,0 +1,17 @@
+***************
+*** 156,162 ****
+  
+    exists = lstat (to, &s) == 0;
+  
+- #if defined (_WIN32) && !defined (__CYGWIN32__)
+    /* Win32, unlike unix, will not erase `to' in `rename(from, to)' but
+       fail instead.  Also, chown is not present.  */
+  
+--- 156,162 ----
+  
+    exists = lstat (to, &s) == 0;
+  
++ #if (defined (_WIN32) && !defined (__CYGWIN32__)) || defined(__amigaos__)
+    /* Win32, unlike unix, will not erase `to' in `rename(from, to)' but
+       fail instead.  Also, chown is not present.  */
+  
diff -urNEBb binutils-2.14-orig/config/mh-amigaos binutils-2.14/config/mh-amigaos
--- binutils-2.14-orig/config/mh-amigaos	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/config/mh-amigaos	2003-12-02 14:09:39.000000000 +0100
@@ -0,0 +1,13 @@
+# Host makefile fragment for Commodore Amiga running AmigaOS.
+
+# There is no standard system compiler.  Assume using GNU C.
+CC = gcc
+CFLAGS = -g -O2 -mstackextend
+
+# We have both types of links under AmigaOS with GNU
+# utils, however the links need to be made in canonical
+# AmigaOS format (foo:bar/bell/file) rather than UNIX
+# format (/foo/bar/bell/file).  When this is fixed, then
+# these can go away.
+SYMLINK = cp
+HARDLINK = cp
diff -urNEBb binutils-2.14-orig/config/mh-morphos binutils-2.14/config/mh-morphos
--- binutils-2.14-orig/config/mh-morphos	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/config/mh-morphos	2003-12-02 14:09:39.000000000 +0100
@@ -0,0 +1,13 @@
+# Host makefile fragment for Commodore Amiga running AmigaOS.
+
+# There is no standard system compiler.  Assume using GNU C.
+CC = gcc
+CFLAGS = -g -O2 
+
+# We have both types of links under AmigaOS with GNU
+# utils, however the links need to be made in canonical
+# AmigaOS format (foo:bar/bell/file) rather than UNIX
+# format (/foo/bar/bell/file).  When this is fixed, then
+# these can go away.
+SYMLINK = cp
+HARDLINK = cp
diff -urNEBb binutils-2.14-orig/configure.in binutils-2.14/configure.in
--- binutils-2.14-orig/configure.in	2003-06-12 15:33:14.000000000 +0200
+++ binutils-2.14/configure.in	2003-12-02 14:09:38.000000000 +0100
@@ -1085,6 +1085,12 @@
   i[[3456]]86-*-msdosdjgpp*)
     host_makefile_frag="config/mh-djgpp"
     ;;
+  *-*-amigaos*)
+    host_makefile_frag="${host_makefile_frag} config/mh-amigaos"
+    ;;
+  *-*-morphos*)
+    host_makefile_frag="${host_makefile_frag} config/mh-morphos"
+    ;;
   *-cygwin*)
     host_makefile_frag="config/mh-cygwin"
     ;;
diff -urNEBb binutils-2.14-orig/gas/ChangeLog-9697 binutils-2.14/gas/ChangeLog-9697
--- binutils-2.14-orig/gas/ChangeLog-9697	2001-03-09 00:06:04.000000000 +0100
+++ binutils-2.14/gas/ChangeLog-9697	2003-12-02 14:09:39.000000000 +0100
@@ -373,6 +373,17 @@
 	* config/tc-sparc.c (md_apply_fix3, cases ..._H44, ..._HIX22): Leave
 	overflow signalling to linker.
 
+Mon Oct 20 21:42:55 1997  Fred Fish  <fnf@ninemoons.com>
+
+	* config/tc-sh.c (insert): Add extra 0 arg for fix_new_exp call.
+	(md_assemble): Add extra 0 arg for fix_new call.
+	(sh_frob_label): Add extra 0 arg for fix_new call.
+	(sh_flush_pending_output): Add extra 0 arg for fix_new call.
+	(s_uses): Add extra 0 arg for fix_new_exp call.
+	(sh_frob_section): Add extra 0 arg for fix_new call.
+	(md_convert_frag): Add extra 0 arg for fix_new calls.
+	(sh_handle_align): Add extra 0 arg for fix_new call.
+
 Mon Oct 20 14:54:06 1997  Klaus K"ampf  <kkaempf@progis.de>
 
 	* makefile.vms: Fix for dec c.
@@ -527,6 +538,12 @@
 	recognizes alphaev5 etc.
 	* configure: Rebuild.
 
+Wed Oct  8 10:40:55 1997  Fred Fish  <fnf@ninemoons.com>
+
+	* config/tc-i386.c (md_assemble): Add extra 0 arg for fix_new_exp calls.
+	(md_create_long_jump): Add extra 0 arg for fix_new calls.
+	(md_estimate_size_before_relax): Ditto.
+
 Wed Oct  8 00:04:05 1997  Gavin Koch  <gavin@cygnus.com>
 
 	* config/tc-mips.c (md_begin): Replace the TARGET_CPU value
@@ -877,6 +894,12 @@
 	for a WORD_PREFIX_OPCODE, change it to ADDR_PREFIX_OPCODE if this
 	is jcxz or a loop instruction.
 
+Mon Aug 25 16:32:00 1997  Steffen Opel  <opel@rumms.uni-mannheim.de>
+
+	* Makefile.in (guide, install-guide, clean-guide): New targets 
+	for AmigaGuide documentation.
+	(install): Add install-info and install-guide.
+
 Mon Aug 25 16:04:14 1997  Nick Clifton  <nickc@cygnus.com>
 
 	* config/tc-v850.c (pre_defined_registers): Add 'hp' as alias for
@@ -3389,6 +3412,12 @@
 	instructions the user requested execute in parallel, can be
 	executed that way.
 
+Sun Nov 17 21:09:55 1996  Kamil Iskra  <iskra@student.uci.agh.edu.pl>
+
+	* config/tc-m68k.c (md_estimate_size_before_relax): Do not
+	output 'bsrl' instructions for external function calls when
+	compiling with '-m68020' or higher.
+
 Thu Nov 14 11:17:49 1996  Martin M. Hunt  <hunt@pizza.cygnus.com>
 
 	* config/tc-d10v.c (write_2_short): Fix bug that wouldn't
diff -urNEBb binutils-2.14-orig/gas/ChangeLog-9899 binutils-2.14/gas/ChangeLog-9899
--- binutils-2.14-orig/gas/ChangeLog-9899	2001-05-16 02:08:20.000000000 +0200
+++ binutils-2.14/gas/ChangeLog-9899	2003-12-02 14:09:39.000000000 +0100
@@ -3472,6 +3472,11 @@
 	* config/tc-d30v.c (md_assemble): Set execution type to unknown
 	after emitting a word of noops.
 
+Sat Jun  6 23:06:18 1998  Fred Fish  <fnf@ninemoons.com>
+
+	* config/tc-i386.c (md_section_align): Re-enable use of forced
+	section alignment based only on BFD_ASSEMBLER being defined.
+
 Fri Jun  5 23:27:04 1998  Alan Modra  <alan@spri.levels.unisa.edu.au>
 
 	* config/tc-i386.c (mode_from_disp_size): Disp16 is mode 2.
@@ -3523,6 +3528,11 @@
 	* config/tc-d30v.c (md_assemble): Store previous segment state
 	with previous instruction.
 
+Thu Jun  4 22:18:50 1998  Fred Fish  <fnf@ninemoons.com>
+
+	* read.c (output_leb128): Do not inline as it is used externally
+	for some configuration.s
+
 Wed Jun  3 18:21:56 1998  Alan Modra  <alan@spri.levels.unisa.edu.au>
 
 	* config/tc-i386.c (SCALE1_WHEN_NO_INDEX): Define.
@@ -3577,6 +3587,10 @@
 	* config/tc-v850.c (md_begin):  Don't create special
 	sections by default.
 
+1998-06-02  David Zaroski  <zaroski@firewall.ninemoons.com>
+
+	* config/tc-m68k.c: Add missing param to add_fix in "case '_'"
+
 Tue Jun  2 14:52:56 1998  Jeffrey A Law  (law@cygnus.com)
 
 	* config/tc-mips.c (macro): For div and udiv, close the
diff -urNEBb binutils-2.14-orig/gas/Makefile.am binutils-2.14/gas/Makefile.am
--- binutils-2.14-orig/gas/Makefile.am	2003-04-24 13:47:30.000000000 +0200
+++ binutils-2.14/gas/Makefile.am	2003-12-02 14:09:39.000000000 +0100
@@ -93,6 +93,7 @@
 # We deliberately omit SOM, since it does not work as a cross assembler.
 
 OBJ_FORMATS = \
+	amigahunk \
 	aout \
 	bout \
 	coff \
@@ -337,6 +338,7 @@
 # OBJ files in config
 
 OBJ_FORMAT_CFILES = \
+	config/obj-amigahunk.c \
 	config/obj-aout.c \
 	config/obj-bout.c \
 	config/obj-coff.c \
@@ -349,6 +351,7 @@
 	config/obj-vms.c
 
 OBJ_FORMAT_HFILES = \
+	config/obj-amigahunk.h \
 	config/obj-aout.h \
 	config/obj-bout.h \
 	config/obj-coff.h \
@@ -364,6 +367,7 @@
 
 TARG_ENV_HFILES = \
 	config/te-386bsd.h \
+	config/te-amiga.h \
 	config/te-aux.h \
 	config/te-delta.h \
 	config/te-delt88.h \
@@ -466,7 +470,7 @@
 	touch stamp-mk.com
 
 EXTRA_DIST = make-gas.com m68k-parse.c itbl-parse.c itbl-parse.h itbl-lex.c
-diststuff: $(EXTRA_DIST) info
+diststuff: $(EXTRA_DIST) info guide
 
 DISTCLEANFILES = targ-cpu.h obj-format.h targ-env.h itbl-cpu.h cgen-desc.h
 
@@ -566,6 +570,8 @@
 # We need all these explicit rules for the multi stuff.  Because of
 # these rules, we don't need one for OBJ_FORMAT_O.
 
+obj-amigahunk.o : $(srcdir)/config/obj-amigahunk.c
+	$(COMPILE) -c $(srcdir)/config/obj-amigahunk.c
 obj-aout.o : $(srcdir)/config/obj-aout.c
 	$(COMPILE) -c $(srcdir)/config/obj-aout.c
 obj-bout.o : $(srcdir)/config/obj-bout.c
@@ -1219,6 +1225,10 @@
   $(srcdir)/config/tc-m68k.h $(BFDDIR)/libaout.h $(INCDIR)/bfdlink.h \
   $(INCDIR)/safe-ctype.h $(INCDIR)/obstack.h subsegs.h \
   dwarf2dbg.h $(INCDIR)/opcode/m68k.h $(srcdir)/config/m68k-parse.h
+DEPTC_m68k_amigaoshunk = $(INCDIR)/symcat.h $(srcdir)/config/obj-amigahunk.h \
+  $(srcdir)/config/tc-m68k.h $(BFDDIR)/libaout.h $(INCDIR)/bfdlink.h \
+  $(INCDIR)/safe-ctype.h $(INCDIR)/obstack.h subsegs.h \
+  dwarf2dbg.h $(INCDIR)/opcode/m68k.h $(srcdir)/config/m68k-parse.h
 DEPTC_m68k_coff = $(INCDIR)/symcat.h $(srcdir)/config/obj-coff.h \
   $(srcdir)/config/tc-m68k.h $(INCDIR)/coff/internal.h \
   $(INCDIR)/coff/m68k.h $(INCDIR)/coff/external.h $(BFDDIR)/libcoff.h \
@@ -1764,6 +1774,9 @@
   $(INCDIR)/elf/external.h $(INCDIR)/bfdlink.h $(srcdir)/config/tc-m68hc11.h \
   $(INCDIR)/safe-ctype.h subsegs.h $(INCDIR)/obstack.h \
   struc-symbol.h $(INCDIR)/aout/aout64.h
+DEPOBJ_m68k_amigaoshunk = $(INCDIR)/symcat.h $(srcdir)/config/obj-amigahunk.h \
+  $(srcdir)/config/tc-m68k.h $(BFDDIR)/libamiga.h $(INCDIR)/bfdlink.h \
+  $(INCDIR)/aout/aout64.h $(INCDIR)/obstack.h
 DEPOBJ_m68k_aout = $(INCDIR)/symcat.h $(srcdir)/config/obj-aout.h \
   $(srcdir)/config/tc-m68k.h $(BFDDIR)/libaout.h $(INCDIR)/bfdlink.h \
   $(INCDIR)/aout/aout64.h $(INCDIR)/obstack.h
@@ -2202,6 +2215,8 @@
 DEP_m68hc11_elf = $(srcdir)/config/obj-elf.h $(INCDIR)/symcat.h \
   $(BFDDIR)/elf-bfd.h $(INCDIR)/elf/common.h $(INCDIR)/elf/internal.h \
   $(INCDIR)/elf/external.h $(INCDIR)/bfdlink.h $(srcdir)/config/tc-m68hc11.h
+DEP_m68k_amigaoshunk = $(srcdir)/config/obj-amigahunk.h $(srcdir)/config/tc-m68k.h \
+  $(BFDDIR)/libamiga.h $(INCDIR)/bfdlink.h
 DEP_m68k_aout = $(srcdir)/config/obj-aout.h $(srcdir)/config/tc-m68k.h \
   $(BFDDIR)/libaout.h $(INCDIR)/bfdlink.h
 DEP_m68k_coff = $(srcdir)/config/obj-coff.h $(srcdir)/config/tc-m68k.h \
diff -urNEBb binutils-2.14-orig/gas/as.c binutils-2.14/gas/as.c
--- binutils-2.14-orig/gas/as.c	2003-04-08 13:47:06.000000000 +0200
+++ binutils-2.14/gas/as.c	2003-12-02 14:09:39.000000000 +0100
@@ -88,6 +88,9 @@
 #ifdef BFD_ASSEMBLER
 segT reg_section, expr_section;
 segT text_section, data_section, bss_section;
+#ifdef TE_AMIGA
+segT data_chip_section, bss_chip_section;
+#endif
 #endif
 
 /* The default obstack chunk size.  If we set this to zero, the
@@ -1044,6 +1047,10 @@
   text_section = subseg_new (TEXT_SECTION_NAME, 0);
   data_section = subseg_new (DATA_SECTION_NAME, 0);
   bss_section = subseg_new (BSS_SECTION_NAME, 0);
+#ifdef TE_AMIGA
+  data_chip_section = subseg_new (".data_chip", 0);
+  bss_chip_section = subseg_new (".bss_chip", 0);
+#endif
   /* @@ FIXME -- we're setting the RELOC flag so that sections are assumed
      to have relocs, otherwise we don't find out in time.  */
   applicable = bfd_applicable_section_flags (stdoutput);
@@ -1054,6 +1061,12 @@
 			 applicable & (SEC_ALLOC | SEC_LOAD | SEC_RELOC
 				       | SEC_DATA));
   bfd_set_section_flags (stdoutput, bss_section, applicable & SEC_ALLOC);
+#ifdef TE_AMIGA
+  bfd_set_section_flags (stdoutput, data_chip_section,
+			 applicable & (SEC_ALLOC | SEC_LOAD | SEC_RELOC));
+  bfd_set_section_flags (stdoutput, bss_chip_section, applicable & SEC_ALLOC);
+#endif
+
   seg_info (bss_section)->bss = 1;
   subseg_new (BFD_ABS_SECTION_NAME, 0);
   subseg_new (BFD_UND_SECTION_NAME, 0);
diff -urNEBb binutils-2.14-orig/gas/config/amigaos.mh binutils-2.14/gas/config/amigaos.mh
--- binutils-2.14-orig/gas/config/amigaos.mh	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/gas/config/amigaos.mh	2003-12-02 14:09:39.000000000 +0100
@@ -0,0 +1,13 @@
+# Host makefile fragment for Commodore Amiga running AmigaOS.
+
+# There is no standard system compiler.  Assume use GNU C.
+CC = gcc
+# There is no support for -g yet.  But use -O instead.
+CFLAGS = -O
+# We have both types of links under AmigaOS with GNU
+# utils, however the links need to be made in canonical
+# AmigaOS format (foo:bar/bell/file) rather than UNIX
+# format (/foo/bar/bell/file).  When this is fixed, then
+# these can go away.
+SYMLINK = cp
+HARDLINK = cp
diff -urNEBb binutils-2.14-orig/gas/config/m68k-parse.h binutils-2.14/gas/config/m68k-parse.h
--- binutils-2.14-orig/gas/config/m68k-parse.h	2001-03-09 00:24:22.000000000 +0100
+++ binutils-2.14/gas/config/m68k-parse.h	2003-12-02 14:09:39.000000000 +0100
@@ -267,6 +267,9 @@
 
   /* The expression itself.  */
   expressionS exp;
+  
+  /* base-relative? */
+  short baserel;
 };
 
 /* The operand modes.  */
diff -urNEBb binutils-2.14-orig/gas/config/m68k-parse.y binutils-2.14/gas/config/m68k-parse.y
--- binutils-2.14-orig/gas/config/m68k-parse.y	2001-09-19 06:33:20.000000000 +0200
+++ binutils-2.14/gas/config/m68k-parse.y	2003-12-02 14:09:39.000000000 +0100
@@ -946,6 +946,7 @@
     }
 
   yylval.exp.size = SIZE_UNSPEC;
+  yylval.exp.baserel = 0;
   if (s <= str + 2
       || (s[-2] != '.' && s[-2] != ':'))
     tail = 0;
@@ -953,18 +954,21 @@
     {
       switch (s[-1])
 	{
+	case 'B':
+          yylval.exp.baserel = 1;
 	case 's':
 	case 'S':
 	case 'b':
-	case 'B':
 	  yylval.exp.size = SIZE_BYTE;
 	  break;
-	case 'w':
 	case 'W':
+          yylval.exp.baserel = 1;
+	case 'w':
 	  yylval.exp.size = SIZE_WORD;
 	  break;
-	case 'l':
 	case 'L':
+          yylval.exp.baserel = 1;
+	case 'l':
 	  yylval.exp.size = SIZE_LONG;
 	  break;
 	default:
diff -urNEBb binutils-2.14-orig/gas/config/morphos.mh binutils-2.14/gas/config/morphos.mh
--- binutils-2.14-orig/gas/config/morphos.mh	1970-01-01 01:00:00.000000000 +0100
+++ binutils-2.14/gas/config/morphos.mh	2003-12-02 14:09:39.000000000 +0100
@@ -0,0 +1,13 @@
+# Host makefile fragment for MorphOS.
+
+# There is no standard system compiler.  Assume use GNU C.
+CC = gcc
+# There is no support for -g yet.  But use -O instead.
+CFLAGS = -O
+# We have both types of links under AmigaOS with GNU
+# utils, however the links need to be made in canonical
+# AmigaOS format (foo:bar/bell/file) rather than UNIX
+# format (/foo/bar/bell/file).  When this is fixed, then
+# these can go away.
+SYMLINK = cp
+HARDLINK = cp
